import QtQuick 2.0
import QtQuick.Controls 1.3
import QtQuick.Window 2.2
import QtQuick.Layouts 1.3

ApplicationWindow {
    id: applicationWindow1
    visible:true
    title: "Jogo da Vida"

    toolBar:ToolBar {
        id : toolbar
        Row {
            anchors.fill: parent
            Button {
                id : playpause
                anchors.verticalCenter: parent.verticalCenter
                iconSource: "img/icon_play.svg"
                states:[
                    State {
                        name: ""
                        when: (!game.playing)
                        PropertyChanges {
                            target: playpause; iconSource: "img/icon_play.svg"; onClicked : game.gameGo()
                        }
                    },
                    State {
                        name: "readytopause"
                        when: (game.playing)
                        PropertyChanges {
                            target: playpause; iconSource: "img/rounded-pause-button.svg"; onClicked : game.gameStop()
                        }
                    }
                ]
                onClicked : game.gameGo()
            }
            Button {
                anchors.verticalCenter: parent.verticalCenter
                iconSource: "img/next-step-circular-button.svg"
                onClicked : game.gameStep()
            }
        }
    }

    ScrollView {
        id: scrollView1
        anchors.fill : parent

          contentItem : Rectangle {
              id: gameDisplay
              property int cellWidth : 25
              property int cellHeight : 25
              width : cellWidth*game.cols
              height: cellHeight*game.rows
              GridView {
                  anchors.fill: parent
                  model: game
                  cellWidth: parent.cellWidth; cellHeight : parent.cellHeight
                  delegate: Item {
                      width : gameDisplay.cellWidth
                      height : gameDisplay.cellHeight
                      Rectangle {
                          anchors.fill : parent
                          color : {
                              if(model.modelData.alive)
                                  return 'black'
                              else
                                  return 'white'
                          }
                          border.width:1
                          MouseArea {
                              anchors.fill: parent
                              onClicked: {
                                  game.toogleCell(index)
                              }
                          }
                      }                      
                  }
              }
        }

    }

}
